///programare dinamica O(N*(Q-P))
#include <vector>
#include <cstdint>
#include <fstream>
#include <cstdlib>
using namespace std;

int main() {
    ifstream        f("pqstr.in");
    ofstream        g("pqstr.out");
    int             N, P, Q; f >> N >> P >> Q;
    vector<int>     A(N);
    vector<int64_t> best(N);
    int64_t         ans = 0;

    for (int i = 0; i < N; i++) f >> A[i];

    for (int i = 0; i < N; i++) {
        for (int j = i - Q; j <= i - P; j++) {
            if (j < 0) continue;
            best[i] = max(best[i], best[j] + abs(A[i] - A[j]));
        }
        ans = max(ans, best[i]);
    }
    g << ans;

    return 0;
}

